
.data

.code

getValue	PROC lpPot:PTR POT

		mov	ecx,lpPot
		mov	eax,(POT PTR [ecx]).fValue

		ret
getValue	ENDP

setValue	PROC lpPot:PTR POT,fValue:REAL4

		mov	ecx,lpPot
		fld	(POT PTR [ecx]).fMin
		fld	(POT PTR [ecx]).fMax
		fld	fValue
		fcom	st(1)
		fstsw	ax
		sahf
		jna @F
			fxch	st(1)
			jmp @End
	@@:
		fcom	st(2)
		fstsw	ax
		sahf
		jnc @End
			fxch	st(2)
	@End:
		fstp	(POT PTR [ecx]).fValue
		fstp	st
		fstp	st
		ret
setValue	ENDP

displayValue	PROC lpPot:PTR POT,hDlg:HWND,dwCtrlID:DWORD
	
		mov	ecx,lpPot
		invoke R4toA,(POT PTR [ecx]).fValue,lpStr,(POT PTR [ecx]).dwPrecision
		invoke SetDlgItemText,hDlg,dwCtrlID,lpStr
		ret

displayValue	ENDP

toggleValue	PROC lpPot:PTR POT

		mov	ecx,lpPot
		lea	edx,(POT PTR [ecx]).fMin	
		fld	(POT PTR [ecx]).fValue
		fcom	real4 ptr [edx]
		fstsw	ax
		sahf
		ja @F
			lea	edx,(POT PTR [ecx]).fMax
	@@:
		push	[edx]
		fstp	st
		pop	(POT PTR [ecx]).fValue
		ret

toggleValue	ENDP

comment %
getEnvelope	PROC lpEnvelope:DWORD

		mov	edx,lpEnvelope
		ASSUME edx:PTR ENV
		;fld	[edx].fCounter
		fld1
	@attack:
	@decay:
	@sustain:
	@release:
		fmulp st(1),st
		ret
		ASSUME edx:NOTHING
getEnvelope	ENDP

filterSample	PROC USES ebx edi esi lpFilter:DWORD,dwNumOfSamples:DWORD

; y[k] = b0*u[k] + b1*u[k-1] + b2*u[k-2] + ... + bm*u[k-m] - a1*y[k-1] - a2*y[k-2] - ... - an*y[k-n]


		counter_begin 1,HIGH_PRIORITY_CLASS
		pushad

		mov	esi,lpFilter
		mov	edx,lpBufferGenPos	; start of buffer
		add	esi,8			; jump over cutoff and resonance
ALIGN 16
	@1:
		push	esi
		mov	ecx,[esi]		; filter order
		fldz
		lea	edi,[esi+ecx*8+8]
		add	esi,4
		mov	ebx,REAL4 PTR [edi+8]	; prefetch y[k-i-1]
		mov	eax,REAL4 PTR [esi+8]	; prefetch u[k-i-1]
		
	; for (i=filter.m;i>0;i--)
	; {
	;	y+=filter.input[i].b*filter.input[i].u
	;	y-=filter.output[i].a*filter.output[i].y
	; }
	@@:

	; inputs
		fld	REAL4 PTR [esi]		; st: u[k-i]
		mov	REAL4 PTR [esi],eax	; u[k-i-1] -> u[k-i]
		fmul	REAL4 PTR [esi+4]	; st: bi*u[k-i]
		faddp	st(1),st
		add	esi,8
	; output feedbacks
		fld	REAL4 PTR [edi]		; st: y[k-i]
		mov	REAL4 PTR [edi],ebx	; y[k-i-1] -> y[k-i]
		fmul	REAL4 PTR [edi+4]	; st: ai*y[k-i]
		fsubp	st(1),st
		add	edi,8


;		fld	REAL4 PTR [esi]		; st: u[k-i]
;		fld	REAL4 PTR [edi]		; st: y[k-i]
;		fmul	REAL4 PTR [edi+4]	; st: ai*y[k-i]
;		fxch	st(1)
;		mov	REAL4 PTR [esi],eax	; u[k-i-1] -> u[k-i]
;		mov	REAL4 PTR [edi],ebx	; y[k-i-1] -> y[k-i]
;		fmul	REAL4 PTR [esi+4]	; st: bi*u[k-i]
;		fxch	st(1)
;		fsubp	st(1),st
;		faddp	st(1),st
;		add	esi,8
;		add	edi,8

		mov	eax,REAL4 PTR [esi+8]	; fetch u[k-i-1]
		mov	ebx,REAL4 PTR [edi+8]	; fetch y[k-i-1]
		sub	ecx,1
		jnz @B
	; y+=filter.b0*input[k]
	; filter.input[1].u=buffer[k]
		fild	WORD PTR [edx]		; st: u[k]
		fst	REAL4 PTR [esi-8]
		fmul	REAL4 PTR [esi]		; st: b0*u[k]
		fadd
		fst	REAL4 PTR [edi-8]	; y[k]->y[k-1]
		fistp	WORD PTR [edx]
		pop	esi
		add	edx,2
		sub	dwNumOfSamples,1
		jnz @1

		popad
		counter_end
		add	dwFilterCycles,eax
		ret

filterSample	ENDP

%