; 
;
; Oscillator CLASS
;
; 


IFNDEF SSN_OSC_CLID

		SSN_OSC_CLID		EQU __SSN_OSC_CLID

; Extern symbols

; Module symbols

		OSC_TYPE_LAST_CODE	EQU 0407h

		OSC_GATE_RST		EQU 00h
		OSC_GATE_FRE		EQU 01h
		OSC_GATE_AMP		EQU 02h
		OSC_GATE_PSW		EQU 03h
		;OSC_GATE_PHA		EQU 04h
		OSC_GATE_LAST_CODE	EQU 04h

		OSC_IS_GATE2		EQU 1
		OSC_IS_GATE		EQU 0

newOSC		MACRO oscType
		newObj OSC,oscType
ENDM


OSC_CLASS	STRUCT	; Oscillator class structure

				MDL_CLASS <>			; inheritance
; Private properties
                fCounter	SAMPLE ?
                fAux1		SAMPLE ?			; auxillary variable for calculations
                dwCounter	dd ?
                dwPsw		dd ?
                dwAmp		dd ?

; Public properties
		rst		GATE2 <>
		amp		GATE <>
		fre		GATE <>
		psw		GATE <>
		;pha		GATE <>

; Virtual functions
		OSC_constructor		PROTO CONSTRUCTOR
		OSC_destructor		PROTO DESTRUCTOR
		OSC_build		PROTO BUILD
		OSC_buildFromXML	PROTO BUILDFROMXML
		OSC_export		PROTO EXPORT
		OSC_exportToXML		PROTO EXPORTTOXML
		OSC_getInput		PROTO GETINPUT
		OSC_info		PROTO INFO
		OSC_reset		PROTO RESET

		OSC_runSAW		PROTO RUN
		OSC_runIMP		PROTO RUN
		OSC_runPSAW		PROTO RUN
		OSC_runTRI		PROTO RUN
		OSC_runPLS		PROTO RUN
		OSC_runSIN		PROTO RUN
		OSC_runRND		PROTO RUN

; Methods

OSC_CLASS	ENDS

ENDIF